#line 1 "C:/Users/richard/Desktop/WORKDIR/Skywire/example/AVR/Skywire_AVR.c"
#line 1 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
#line 1 "c:/c4w/mikroelektronika/mikroc pro for avr/include/stdint.h"




typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;



typedef signed char int_fast8_t;
typedef signed int int_fast16_t;
typedef signed long int int_fast32_t;


typedef unsigned char uint_fast8_t;
typedef unsigned int uint_fast16_t;
typedef unsigned long int uint_fast32_t;


typedef signed int intptr_t;
typedef unsigned int uintptr_t;


typedef signed long int intmax_t;
typedef unsigned long int uintmax_t;
#line 1 "c:/c4w/mikroelektronika/mikroc pro for avr/include/stddef.h"



typedef int ptrdiff_t;
typedef unsigned int size_t;
typedef unsigned int wchar_t;
#line 1 "c:/c4w/mikroelektronika/mikroc pro for avr/include/string.h"





void * memchr(void *p, char n, unsigned int v);
int memcmp(void *s1, void *s2, int n);
void * memcpy(void * d1, void * s1, int n);
void * memmove(void * to, void * from, int n);
void * memset(void * p1, char character, int n);
char * strcat(char * to, char * from);
char * strchr(char * ptr, char chr);
int strcmp(char * s1, char * s2);
char * strcpy(char * to, char * from);
int strlen(char * s);
char * strncat(char * to, char * from, int size);
char * strncpy(char * to, char * from, int size);
int strspn(char * str1, char * str2);
char strcspn(char * s1, char * s2);
int strncmp(char * s1, char * s2, char len);
char * strpbrk(char * s1, char * s2);
char * strrchr(char *ptr, char chr);
char * strstr(char * s1, char * s2);
char * strtok(char * s1, char * s2);
#line 1 "c:/c4w/mikroelektronika/mikroc pro for avr/include/stdbool.h"



 typedef char _Bool;
#line 23 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
typedef void ( *at_cmd_cb )( char *buffer );
#line 33 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
typedef void ( *at_write_p )( unsigned char data_out );
#line 40 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
typedef enum
{
#line 44 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
 AT_CMD_UNKNOWN = 0,
#line 47 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
 AT_CMD_GET = 1,
#line 50 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
 AT_CMD_SET = 2,
#line 53 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
 AT_CMD_TEST = 3,
#line 56 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
 AT_CMD_EXEC = 4,

}at_type_t;
#line 68 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
typedef struct
{
#line 72 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
 uint32_t hash;
#line 75 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
 uint32_t timeout;
#line 78 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
 at_cmd_cb getter;
#line 81 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
 at_cmd_cb setter;
#line 84 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
 at_cmd_cb tester;
#line 87 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
 at_cmd_cb executer;

}at_cmd_t;
#line 107 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
void at_init( at_cmd_cb default_callback, at_write_p default_write,
 uint8_t *buffer_ptr, uint16_t buffer_size );
#line 119 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
void at_rx( char rx_input );
#line 127 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
void at_tick( void );
#line 137 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
void at_cmd_single( char *cmd );
#line 149 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
void at_cmd_double( char *cmd, char *arg_1 );
#line 162 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
void at_cmd_triple( char *cmd, char *arg_1, char *arg_2 );
#line 178 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
void at_cmd_save( char *cmd, uint32_t timeout,
 at_cmd_cb getter, at_cmd_cb setter,
 at_cmd_cb tester, at_cmd_cb executer );
#line 187 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
void at_process( void );
#line 20 "C:/Users/richard/Desktop/WORKDIR/Skywire/example/AVR/Skywire_AVR.c"
sbit SKYWIRE_EN at PORTA7_bit;
sbit SKYWIRE_RST at PORTA6_bit;
#line 26 "C:/Users/richard/Desktop/WORKDIR/Skywire/example/AVR/Skywire_AVR.c"
 _Bool  measure_f;
#line 31 "C:/Users/richard/Desktop/WORKDIR/Skywire/example/AVR/Skywire_AVR.c"
uint8_t buffer[ 256 ] = { 0 };
#line 36 "C:/Users/richard/Desktop/WORKDIR/Skywire/example/AVR/Skywire_AVR.c"
char caller_id[ 20 ] = { 0 };
#line 41 "C:/Users/richard/Desktop/WORKDIR/Skywire/example/AVR/Skywire_AVR.c"
float temperature = 0.0F;
#line 46 "C:/Users/richard/Desktop/WORKDIR/Skywire/example/AVR/Skywire_AVR.c"
void LOG( char *txt )
{
 char *ptr = txt;

 while( *ptr )
 Soft_UART_Write( *ptr++ );
}
#line 67 "C:/Users/richard/Desktop/WORKDIR/Skywire/example/AVR/Skywire_AVR.c"
void system_init( void )
{
 DDA7_bit = 1;
 DDA7_bit = 1;

 Soft_UART_Init( &PORTA, 1, 4, 9600, 0 );
 UART1_Init( 115200 );
 TWI_Init( 100000 );
 TCCR1A = 0x80;
 TCCR1B = 0x09;
 OCR1AH = 0x1F;
 OCR1AL = 0x3F;
 OCIE1A_bit = 1;
 UCSRB |= ( 1 << RXCIE );
 SREG |= ( 1 << SREG_I );
 LOG( "\r\n_______________________________\r\n System Initialized\r\n" );
}
#line 88 "C:/Users/richard/Desktop/WORKDIR/Skywire/example/AVR/Skywire_AVR.c"
void skywire_power_on( void )
{
 SKYWIRE_EN = 0;
 Delay_ms( 5000 );
 SKYWIRE_EN = 1;
 Delay_ms( 3000 );
 LOG( "\r\nSkywire Initialized\r\n" );
}
#line 100 "C:/Users/richard/Desktop/WORKDIR/Skywire/example/AVR/Skywire_AVR.c"
void rsp_handler( char *rsp )
{
 char tmp[ 25 ] = { 0 };

 LOG( "Response : \r\n" );
 LOG( rsp );
 LOG( "\r\n" );
 if( !strncmp( "\r\nRING", rsp, 6 ) )
 measure_f =  1 ;
}
#line 114 "C:/Users/richard/Desktop/WORKDIR/Skywire/example/AVR/Skywire_AVR.c"
void callerid_handler( char *rsp )
{
 char *tmp_s;
 char *tmp_e;

 tmp_s = strchr( rsp, '\"' );
 tmp_e = strchr( tmp_s + 1, '\"' );
 strncpy( caller_id, tmp_s, tmp_e - tmp_s + 1 );
}
#line 127 "C:/Users/richard/Desktop/WORKDIR/Skywire/example/AVR/Skywire_AVR.c"
void measure_temp( void )
{
 int raw_temp;
 uint8_t tmp_data[ 2 ] = { 0x00 };

 TWI_Start();
 TWI_Write( ( 0x48 << 1 ) | 0x00 );
 TWI_Write( 0x00 );
 TWI_Stop();
 TWI_Start();
 TWI_Write( ( 0x48 << 1 ) | 0x01 );
 tmp_data[ 0 ] = TWI_Read( 1 );
 tmp_data[ 1 ] = TWI_Read( 0 );
 TWI_Stop();

 raw_temp = ( ( tmp_data[ 0 ] << 8 ) | tmp_data[ 1 ] ) >> 4;

 if( raw_temp & ( 1 << 11 ) )
 raw_temp |= 0xF800;

 temperature = ( float )( raw_temp * 0.0625 );
}
#line 153 "C:/Users/richard/Desktop/WORKDIR/Skywire/example/AVR/Skywire_AVR.c"
void reply_to_caller( void )
{
 char tmp[ 30 ] = { 0 };
 char cmd_content[ 30 ] = { 0 };
 char reply_content[ 256 ] = { 0 };

 strcat( cmd_content, "AT+CMGS=" );
 strcat( cmd_content, caller_id );
 strcat( reply_content, "Temperature : " );
 FloatToStr( temperature, tmp );
 strcat( reply_content, Ltrim( tmp ) );
 strcat( reply_content, " C" );
 at_cmd_double( cmd_content, reply_content );
}


void main()
{
 measure_f =  0 ;
 system_init();
 skywire_power_on();
 at_init( rsp_handler, UART1_Write, buffer, sizeof( buffer ) );
 at_cmd_save( "+CLCC", 1000,  ((void *)0) ,  ((void *)0) ,  ((void *)0) , callerid_handler );
 at_cmd_single( "AT" );
 at_cmd_single( "AT" );
 at_cmd_single( "AT" );
 at_cmd_single( "AT+CSCS=\"GSM\"" );
 at_cmd_single( "AT+CMGF=1" );

 while( 1 )
 {
 at_process();

 if( measure_f )
 {
 measure_temp();
 at_cmd_single( "AT+CLCC" );
 at_cmd_single( "ATH" );
 Delay_ms( 2000 );
 reply_to_caller();
 measure_f =  0 ;
 }
 }
}
#line 201 "C:/Users/richard/Desktop/WORKDIR/Skywire/example/AVR/Skywire_AVR.c"
void uart_rx_ISR() iv IVT_ADDR_USART__RXC ics ICS_AUTO
{
 char tmp = UART_Read();
 at_rx( tmp );
}

void Timer1Overflow_ISR() org IVT_ADDR_TIMER1_COMPA
{
 at_tick();
}
